<id>
ImageShack Uploader
</id>

<version>
1.0 final
</version>

<mod info>
This is the YaBB 2.0/2.1 version of this modification.

This is an extremely simple hack that allows you to place an ImageShack uploader in your forums.  That way, if you don't have attachments enabled, or you want to conserve server space, you can allow your visitors to upload images to ImageShack, and then automatically receive the code to put in their posts.

Known Issues:
1)  At the moment, you can only assign one color to the text within the ImageShack iFrame.  This means, if you have a template with a white background, and a template with a black background, the text most likely will only be visible on one of those templates.  I am working on trying to assign a color from your template's style sheet to the text, so it will be visible on all templates.

Credits:
As always, all credits go to the YaBB development team for putting together such a great piece of software.  In addition, all credits go to the BoardMod development team for the same reasons.

For this particular mod, credit needs to go to the ImageShack team for making it so easy to implement this mod.  The information I used to create this mod can be found at:
http://www.imageshack.us/syndicate.php

In addition, I would like to thank T3rrabug and Gabriel Finkelstein for translating the language files for this mod to German and Spanish (respectively).

Changelog:
From version 0.1f
Added an option to disable the ImageShack iFrame.
From version 0.1e
Made a minor formatting change to make this mod compatible with YaBB 2.0
From version 0.1d
Fixed some weird corruption problems with German language file.
From version 0.1c
Added a regex to remove any non-numeric characters from the variables stored by this mod.
Fixed a few spots in German translation (thanks Rebus)
From version 0.1b
Added German translation of ImageShack.lng file (thanks t3rrabug)
Added Spanish translation (thanks Gabriel Finkelstein)
Fixed input size issue (it turns out - if you place a # symbol in front of the text color variable, as you normally would in HTML, it renders all of the settings for the iframe useless.  In other words, #ffffff will make none of the customization work.  Instead, you need to type simply ffffff)
Added new warning about text color input
From version 0.1
Removed ModList.pl (which was placed in the original package by mistake).
Fixed the issue that caused the wrong mod settings menu item to be highlighted.
</mod info>

<author>
Curtiss Grymala
</author>

<homepage>
http://dchelp.dcevolution.net
</homepage>

<edit file>
Sources/Post.pl
</edit file>

<search for>
LoadLanguage("FA");
</search for>

<add after>
LoadLanguage("ImageShack");
</add after>

<search for>
	# /File Attachment's Browse Box Code
</search for>

<add after>
	# ImageShack Uploader IFrame Code
	fopen(FILE, "$vardir/ImageShack.txt");
		$thedata = <FILE>;
	fclose(FILE);
	($issize,$istxtcolor,$iswidth,$isheight,$is_on_off) = split (/\|/, $thedata); 
if($is_on_off != 1) {
	$yymain .= qq~
	<tr>
		<td width="23%" valign="top"><b>$imageshack_txt{'2'}</b></td>
		<td><table><tr><td><iframe src="http://www.imageshack.us/iframe.php?txtcolor=$istxtcolor&type=forum&size=$issize" scrolling="no" allowtransparency="true" frameborder="0" width="$iswidth" height="$isheight"> $imageshack_txt{'1'} </iframe></td><td><img src="$modimgurl/ImageShack/imageshack.png" alt="" /></td></tr></table>
		</td>
	</tr>
	~;
}
	# /ImageShack Uploader IFrame Code
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$imageshack_mod = "ImageShack Uploader|Curtiss Grymala|Adds a form element to allow users to upload images directly to ImageShack's server.  You can edit the text color within the ImageShack iFrame, as well as the height and the width of the iFrame.  The information I used to create this mod can be found at <a href=\"http://www.imageshack.us/syndicate.php\">http://www.imageshack.us/syndicate.php</a>|1.0 final|01-23-2006";
	push (@installed_mods, "$imageshack_mod");
</add before>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$imageshack_mod = "imageshack|ImageShack Settings|Edit Your ImageShack Uploader Settings|";
push (@boardmod_mods, "$imageshack_mod");
</add before>

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
LoadLanguage("Register");
</search for>

<add after>
LoadLanguage("ImageShack");
</add after>

<search for>
	$FORM{'agreement'} =~ s~\n\Z~~;
	fopen(AGREE, ">$langdir/$agreementlanguage/agreement.txt");
	print AGREE $FORM{'agreement'};
	fclose(AGREE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}
</search for>

<add after>
sub ModifyImageShack {
	&is_admin_or_gmod;
	my( $imageshacksettings, $line );
fopen(IMAGESHACK, "$vardir/ImageShack.txt");
	$thedata = <IMAGESHACK>;
fclose(IMAGESHACK);
($issize,$istxtcolor,$iswidth,$isheight,$is_on_off) = split (/\|/, $thedata); 
$yymain .= qq~
<table>
  <tr valign="top">
    <td class="titlebg" align="left" colspan="3">
      <img src="$imagesdir/xx.gif" alt="$imageshack_txt{'3'}" border="0" />
      <b>$imageshack_txt{'3'}</b>
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg" align="left" colspan="3">
      $imageshack_txt{'4'}
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
	<form action="$adminurl?action=imageshack2" method="post">
      $imageshack_txt{'5'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="issize" value="$issize" />
    </td>
    <td class="windowbg" align="center" rowspan="5" valign="middle">
      <img src="$modimgurl/ImageShack/imageshack.png" alt="" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'6'}
      <br /><span style="font-style:italic;font-size:10px;">$imageshack_txt{'10'}</span>
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="istxtcolor" value="$istxtcolor" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'7'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="iswidth" value="$iswidth" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'8'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="isheight" value="$isheight" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'11'}
    </td>
    <td class="windowbg3" align="left">
      <input type="checkbox" name="is_on_off" value="1"~;
  if($is_on_off == 1) {
  	$yymain .= qq~ checked="checked"~;
  }
$yymain .= qq~ />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg" align="right" colspan="2">
      <input type="submit" value="$imageshack_txt{'9'}" name="ImageShackSubmit" />
    </td>
  </tr>
</table>
~;

	$yytitle = "$imageshack_txt{'3'}";
	$action_area = "imageshack";
	&AdminTemplate;
	exit;
}

sub ModifyImageShack2 {
	&is_admin_or_gmod;
	$issize = $FORM{'issize'};
	$istxtcolor = $FORM{'istxtcolor'};
	$iswidth = $FORM{'iswidth'};
	$isheight = $FORM{'isheight'};
	$is_on_off = $FORM{'is_on_off'};
	$issize =~ tr/\r//d;
	$issize =~ s~\A\n~~;
	$issize =~ s~\n\Z~~;
	$issize =~ s/[^0-9^_]//g;
	$istxtcolor =~ tr/\r//d;
	$istxtcolor =~ s~\A\n~~;
	$istxtcolor =~ s~\n\Z~~;
	$istxtcolor =~ s/[^0-9^_]//g;
	$iswidth =~ tr/\r//d;
	$iswidth =~ s~\A\n~~;
	$iswidth =~ s~\n\Z~~;
	$iswidth =~ s/[^0-9^_]//g;
	$isheight =~ tr/\r//d;
	$isheight =~ s~\A\n~~;
	$isheight =~ s~\n\Z~~;
	$isheight =~ s/[^0-9^_]//g;
fopen(IMAGESHACK, ">$vardir/ImageShack.txt");
	print IMAGESHACK qq~$issize|$istxtcolor|$iswidth|$isheight|$is_on_off~;
fclose(IMAGESHACK); 
 	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}

</add after>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'modagreement2',"AdminEdit.pl&ModifyAgreement2",
</search for>

<add after>
'imageshack',"AdminEdit.pl&ModifyImageShack",
'imageshack2',"AdminEdit.pl&ModifyImageShack2",
</add after>